Summary: Scalable and open-source content-based spam filter.
Name: dspam
Version: 3.8.0
Release: 1tr
Group: Trustix Official
Source: http://dspam.nuclearelephant.com/sources/dspam-%{version}.tar.gz
Source1: dspam.conf
Source2: dspam.sysconfig
Source3: dspam.init
Source4: dspam.cron
Source5: dspam-httpd.conf
Source6: dspam.logrotate
Source7: dspam_inst.sh
Source8: dspam-retrain
Source9: dspam-README.trustix
Patch0: dspam-webconfig.patch
License: GPL
BuildRoot: /var/tmp/%{name}-%{version}-root
BuildRequires: openldap-devel 
Requires: clamav
PreReq: tsl-utils chkconfig shadow-utils


%define user_name  dspam
%define group_name dspam

%description
DSPAM is an open-source, freely available anti-spam solution designed
to combat unsolicited commercial email using advanced statistical
analysis. In short, DSPAM filters spam by learning what spam is and
isn't. It does this by learning each user's individual mail behavior.
This allows DSPAM to provide highly-accurate, personalized filtering
for each user on even a large system and provides an administratively
maintenance free solution capable of learning each user's email
behaviors with very few false positives.

%package libs
Summary: Dspam - Shared libraries
Group: Trustix Official

%description libs
This package contains the shared libraries (*.so*) needed load and
use dspam.

%package devel
Requires: dspam-libs
Summary: Dspam - Development header files and libraries
Group: Trustix Official

%description devel
This package contains the development header files and libraries.

%package mysql
Summary: MySQL driver for Dspam
Group: Trustix Official
Requires: %{name} = %{version}
Requires: mysql-libs openldap-libs
BuildRequires: mysql-devel

%description mysql
The mysql driver for dspam

%package cgi
Summary: Web administration GUI for DSPAM
Group: Trustix Official
Requires: %{name} = %{version}
Requires: apache perl-gd perl-gd-graph perl-gd-graph3d perl-gd-textutil

%description cgi
Web administration GUI for DSPAM.

%prep
%setup -q
%patch0 -p1

%build
./configure  --prefix=/usr \
	     --sysconfdir=/etc \
	     --enable-daemon \
	     --enable-clamav \
	     --enable-neural-networking \
	     --enable-long-usernames \
	     --enable-virtual-users \
	     --with-dspam-home=/var/lib/dspam \
	     --with-logdir=/var/log/dspam \
	     --with-storage-driver=hash_drv,mysql_drv \
	     --with-mysql-includes=%{_includedir}/mysql --with-mysql-libraries=%{_libdir} \
	     --mandir=/usr/share/man  
make

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"
make install DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_includedir}/dspam
install -d $RPM_BUILD_ROOT/var/log/dspam
install -d $RPM_BUILD_ROOT/var/run/dspam
install -d $RPM_BUILD_ROOT%{_datadir}/dspam-mysql
install -d $RPM_BUILD_ROOT%{_datadir}/dspam
install -d $RPM_BUILD_ROOT/var/lib/dspam/data
install -d $RPM_BUILD_ROOT%{_libdir}/dspam
install -d $RPM_BUILD_ROOT/cron.daily
install -d $RPM_BUILD_ROOT/logrotate.d
install -d $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -d $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily
install -d $RPM_BUILD_ROOT%{_sysconfdir}/init.d
install -d $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
install -d $RPM_BUILD_ROOT/home/httpd/sites/dspam/templates
install -d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d

install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/dspam
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/dspam
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT/etc/init.d/dspam
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc/dspam.conf
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/httpd-dspam.conf
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/dspam
install -m 755 %{SOURCE7} scripts/
install -m 755 %{SOURCE8} $RPM_BUILD_ROOT/usr/bin/dspam-retrain
install -m 644 %{SOURCE9} README.trustix
mv $RPM_BUILD_ROOT%{_libdir}/lib*_drv.so* $RPM_BUILD_ROOT%{_libdir}/dspam/
install -m0644 src/tools.mysql_drv/*.sql $RPM_BUILD_ROOT%{_datadir}/dspam-mysql/

install -m 755 webui/cgi-bin/*.cgi $RPM_BUILD_ROOT/home/httpd/sites/dspam/
install -m 755 webui/cgi-bin/configure.pl $RPM_BUILD_ROOT/home/httpd/sites/dspam/
install -m0644 webui/cgi-bin/*.txt $RPM_BUILD_ROOT/home/httpd/sites/dspam/
install -m0644 webui/cgi-bin/default.prefs $RPM_BUILD_ROOT/home/httpd/sites/dspam/
install -m0644 webui/cgi-bin/admins $RPM_BUILD_ROOT/home/httpd/sites/dspam/
install -m0644 webui/htdocs/*.css $RPM_BUILD_ROOT/home/httpd/sites/dspam/
install -m0644 webui/htdocs/*.gif $RPM_BUILD_ROOT/home/httpd/sites/dspam/
install -m0644 webui/cgi-bin/templates/*.html $RPM_BUILD_ROOT/home/httpd/sites/dspam/templates/

perl -pi -e "s|\"\/\"\;|\"\/dspam\"\;|g" $RPM_BUILD_ROOT/home/httpd/sites/dspam/configure.pl


touch $RPM_BUILD_ROOT//home/httpd/sites/dspam/.htpasswd


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"

%pre
if [ -z "`getent group %{group_name}`" ] ; then
    /usr/sbin/groupadd %{group_name}
fi
if [ -z "`getent passwd %{user_name}`" ] ; then
    /usr/sbin/useradd -m -g %{group_name} -s /bin/false \
                      %{user_name}
    usermod -G mail %{group_name}
fi



%post
chkconfig --add dspam
if [ $1 = 2 ]; then
        /sbin/restart_maybe dspam
fi


%preun
if [ $1 = 0 ]; then
   %{_initdir}/dspam stop
   /sbin/chkconfig --del dspam
fi

%post libs
/sbin/ldconfig

%postun libs
/sbin/ldconfig

%post mysql
/sbin/ldconfig

%postun mysql
/sbin/ldconfig


%files
%defattr(-,root,root,0755)
%doc doc/*.txt README* RELEASE.NOTES CHANGELOG txt/*.txt scripts/dspam_inst.sh
/etc/init.d/dspam
%{_sysconfdir}/cron.daily/dspam
%attr(0644,root,mail) %config(noreplace) %{_sysconfdir}/dspam.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/dspam
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/dspam
%attr(0755,root,root) %{_bindir}/cssclean
%attr(0755,root,root) %{_bindir}/csscompress
%attr(0755,root,root) %{_bindir}/cssconvert
%attr(0755,root,root) %{_bindir}/cssstat
%attr(-,root,mail) %{_bindir}/dspam_admin
%attr(-,root,mail) %{_bindir}/dspam
%attr(0755,root,root) %{_bindir}/dspam_2sql
%attr(0755,root,root) %{_bindir}/dspam_clean
%attr(0755,root,root) %{_bindir}/dspam_crc
%attr(0755,root,root) %{_bindir}/dspamc
%attr(0755,root,root) %{_bindir}/dspam_dump
%attr(0755,root,root) %{_bindir}/dspam_logrotate
%attr(0755,root,root) %{_bindir}/dspam_merge
%attr(0755,root,root) %{_bindir}/dspam_stats
%attr(0755,root,root) %{_bindir}/dspam_train
%attr(0755,root,root) %{_bindir}/dspam-retrain
%{_mandir}/man1/*
%dir %attr(0755,root,root) /usr/lib/dspam
%dir %attr(0750,root,mail) /var/lib/dspam
%dir %attr(0750,root,mail) /var/lib/dspam/data
%dir %attr(0750,root,mail) /var/log/dspam
%dir %attr(0755,root,root) /var/run/dspam

%files libs
%defattr(-,root,root)
%{_libdir}/libdspam.so.*
%{_libdir}/dspam/libhash_drv.so*

%files devel
%defattr(-,root,root)
%{_libdir}/libdspam.so
%{_libdir}/libdspam.la
%{_libdir}/libdspam.a
%{_includedir}/dspam
%{_libdir}/pkgconfig/dspam.pc
%{_mandir}/man3/*

%files mysql
%defattr(-,root,root)
%attr(0755,root,root) %{_libdir}/dspam/libmysql_drv.so*
%dir %attr(0755,root,root) %{_datadir}/dspam-mysql
%attr(0644,root,root) %{_datadir}/dspam-mysql/*

%files cgi
%defattr(-,dspam,dspam)
%dir /home/httpd/sites/dspam
%dir /home/httpd/sites/dspam/templates
/home/httpd/sites/dspam/*.txt
/home/httpd/sites/dspam/*.gif
/home/httpd/sites/dspam/*.css
/home/httpd/sites/dspam/*.cgi
/home/httpd/sites/dspam/*.pl
/home/httpd/sites/dspam/templates/*.html
%config(noreplace) %attr(0644,root,root) /etc/httpd/conf.d/httpd-dspam.conf
%config(noreplace) /home/httpd/sites/dspam/default.prefs
%config(noreplace) /home/httpd/sites/dspam/admins
%config(noreplace) /home/httpd/sites/dspam/.htpasswd


%changelog
* Thu Jan 10 2008 Nived Gopalan <nived at trustix dot org> 3.8.0-1tr
- Initial release

